function R = REObjEmpRisk(wprime,wgrid,V,Vw,Theta,params,order,opts)

%REval: Calculate the employed searchers problem


% Load Parameters and Define Functional Forms
[r,ddelta,eeta,ggamma,bl,gg,b,ubi,MaxUI,bRet,kkappa,ssigma,nnu,T,TYoung,TOld,TScar,llambu,llambe,aalphah,eepsilon,lb,ub,delt,Nd,Na,Nb,Nw,Nh,Nl,na,nw,nt,N,NScar,S,MuA,MuH,MuL,SigA,SigH,SigL,SigAL,SigAH,SigHL,bbeta,U,p,q,xxi,phi,IncFun,w0,freq,bUITest,blUITest,bbarUITest,MaxUIUITest,ggammaUITest,iq,Epsnodes,MuEps,SigEps,StdEps,SigXi,MPIncreaseSA,MPDecreaseSA,MPIncreaseSH,MPDecreaseSH,MPIncreaseSL,MPDecreaseSL,exitProb,errtol] = Parameters(params, order, opts);


% Calculate the value of being employed
% V1    = permute(repmat(interp1(wgrid.',V,full(wprime).','v5cubic'),1,1,1,Nw),[4,2,3,1]);          % Interpolated value of a job at (wprime,a)
% V     = repmat(V,1,1,1,nw); % Interpolated value of a job at (w,a)
% Theta = permute(repmat(interp1(wgrid,Theta,wprime','v5cubic'),1,1,1,Nw),[4,2,3,1]);      % Interpolated tightness at (wprime,a)
% Theta(Theta<0) = 0;
% phat     = p(Theta);                    % Job-finding probability
% clear Theta;

%V    = permute(interp1(wgrid.',V,wprime.','v5cubic'),[2,3,1]);          % Interpolated value of a job at (wprime,a)
V     = permute(interp1(wgrid.',permute(V,[2,1,3,4]),wprime.','linear'),[2,3,4,1]);     % Interpolated value of employment at (wprime,a)
Theta = permute(interp1(wgrid.',permute(Theta,[2,1,3,4]),wprime.','linear'),[2,3,4,1]);  % Interpolated tightness at every (wprime,a)
% $$$ V    = permute(interp1(wgrid.',V,wprime.','linear'),[2,3,1]);          % Interpolated value of a job at (wprime,a)
Vw     = repmat(Vw,1,1,1,nw); % Interpolated value of a job at (w,a)
%Theta = permute(interp1(wgrid.',Theta,wprime.','v5cubic'),[2,3,1]);      % Interpolated tightness at (wprime,a)
% $$$ Theta = permute(interp1(wgrid.',Theta,wprime.','linear'),[2,3,1]);      % Interpolated tightness at (wprime,a)
clear wprime;
Theta(Theta<0) = 0;
phat     = p(Theta);                    % Job-finding probability
clear Theta;

R        = llambe.*phat.*V + (1-llambe.*phat).*Vw; % Return to search of employed worker (nw x na)

end