function Ru = RubObj(wprime,wgrid,Vw,Vb,Thetab,params,order,opts)

%RuEval: Calculate the unemployed searchers value

% Load Parameters and Define Functional Forms
[r,ddelta,eeta,ggamma,bl,gg,b,ubi,MaxUI,bRet,kkappa,ssigma,nnu,T,TYoung,TOld,TScar,llambu,llambe,aalphah,eepsilon,lb,ub,delt,Nd,Na,Nb,Nw,Nh,Nl,na,nw,nt,N,NScar,S,MuA,MuH,MuL,SigA,SigH,SigL,SigAL,SigAH,SigHL,bbeta,U,p,q,xxi,phi,IncFun,w0,freq,bUITest,blUITest,bbarUITest,MaxUIUITest,ggammaUITest,iq,Epsnodes,MuEps,SigEps,StdEps,SigXi,MPIncreaseSA,MPDecreaseSA,MPIncreaseSH,MPDecreaseSH,MPIncreaseSL,MPDecreaseSL,exitProb,errtol] = Parameters(params, order, opts);


% Calculate the return to search for unemployed workers


% Vw     = permute(repmat(interp1(wgrid.',Vw,wprime.','v5cubic'),1,1,1,Nw),[4,2,3,1]);     % Interpolated value of employment at (wprime,a)
% Thetab = permute(repmat(interp1(wgrid.',Thetab,wprime.','v5cubic'),1,1,1,Nw),[4,2,3,1]);  % Interpolated tightness at every (wprime,a)
%Vw     = permute(interp1(wgrid.',Vw,wprime.','v5cubic'),[2,3,4,1]);     % Interpolated value of employment at (wprime,a)
%Thetab = permute(interp1(wgrid.',Thetab,wprime.','v5cubic'),[2,3,4,1]);  % Interpolated tightness at every (wprime,a)
Vw     = permute(interp1(wgrid.',Vw,wprime.','linear'),[2,3,4,1]);     % Interpolated value of employment at (wprime,a)
Thetab = permute(interp1(wgrid.',Thetab,wprime.','linear'),[2,3,4,1]);  % Interpolated tightness at every (wprime,a)
clear wprime;
Vb     = repmat(Vb,1,1,1,nw);
Thetab(Thetab<0) = 0;
phat     = p(Thetab);                               % Job-finding probability
clear Theta;

Ru       = llambu*phat.*Vw + (1-llambu*phat).*Vb;  % Return to search (nw x na)

end