function Ru = RublObj(wprime,wgrid,Vw,Vbl,Thetabl,params,order,opts)

%RuEval: Calculate the unemployed searchers value

% Load Parameters and Define Functional Forms
[r,ddelta,eeta,ggamma,bl,gg,b,ubi,MaxUI,bRet,kkappa,ssigma,nnu,T,TYoung,TOld,TScar,llambu,llambe,aalphah,eepsilon,lb,ub,delt,Nd,Na,Nb,Nw,Nh,Nl,na,nw,nt,N,NScar,S,MuA,MuH,MuL,SigA,SigH,SigL,SigAL,SigAH,SigHL,bbeta,U,p,q,xxi,phi,IncFun,w0,freq,bUITest,blUITest,bbarUITest,MaxUIUITest,ggammaUITest,iq,Epsnodes,MuEps,SigEps,StdEps,SigXi,MPIncreaseSA,MPDecreaseSA,MPIncreaseSH,MPDecreaseSH,MPIncreaseSL,MPDecreaseSL,exitProb,errtol] = Parameters(params, order, opts);


% Calculate the return to search for unemployed workers



%Vw     = permute(interp1(wgrid.',Vw,wprime.','v5cubic'),[2,3,4,1]);% Interpolated value of employment at (wprime,a)
%Thetabl = permute(interp1(wgrid.',Thetabl,wprime.','v5cubic'),[2,3,4,1]);  % Interpolated tightness at every (wprime,a)
Vw     = permute(interp1(wgrid.',Vw,wprime.','linear'),[2,3,4,1]);     % Interpolated value of employment at (wprime,a)
Thetabl = permute(interp1(wgrid.',Thetabl,wprime.','linear'),[2,3,4,1]);  % Interpolated tightness at every (wprime,a)
clear wprime;
Vbl    = repmat(Vbl,1,1,1,nw); % Repeats each element in Vu nw times to make it comformable with Vhat
Thetabl(Thetabl<0) = 0;
phat     = p(Thetabl);                               % Job-finding probability
clear Thetabl;

Ru       = llambu.*phat.*Vw + (1-llambu.*phat).*Vbl;  % Return to search (nw x na)

end