function SaveFinalParams(params, order, opts)

%% Define Parameters for the Model with state (w,a) and contractible assets
% r,delta,eta,gamma,lambda_e,lambda_u,delta_h,fix_h,var_h,alpha_h,y,b,bl,kappa,sigma,Ns,Nw,Na,Nh,nw,na,nx,T
% beta = 1/(1 + r)

[r,ddelta,eeta,ggamma,bl,gg,b,ubi,MaxUI,bRet,kkappa,ssigma,nnu,T,TYoung,TOld,TScar,llambu,llambe,aalphah,eepsilon,lb,ub,delt,Nd,Na,Nb,Nw,Nh,Nl,na,nw,nt,N,NScar,S,MuA,MuH,MuL,SigA,SigH,SigL,SigAL,SigAH,SigHL,bbeta,U,p,q,xxi,phi,IncFun,w0,freq,bUITest,blUITest,bbarUITest,MaxUIUITest,ggammaUITest,iq,Epsnodes,MuEps,SigEps,StdEps,SigXi,MPIncreaseSA,MPDecreaseSA,MPIncreaseSH,MPDecreaseSH,MPIncreaseSL,MPDecreaseSL,exitProb,errtol] = Parameters(params, order, opts);


paramNames = {'r','ddelta','eeta','ggamma','bl','gg','b', ...
              'ubi','MaxUI','bRet','kkappa','ssigma','nnu', ...
              'T','TYoung','TOld','TScar','llambu','llambe','aalphah', ...
              'lba','lbh','lbl','lbb','lbt','lbw','uba','ubh','ubl','ubb','ubt','ubw', ...
              'delth','deltl','Nd','Na','Nb','Nw','Nh','Nl','na','nw','nt','N','NScar', ...
              'S','MuA','MuH','MuL','SigA','SigH','SigL','SigAL','SigAH','SigHL', ...
              'bbeta','w0','freq','Epsnodes','MuEps','SigEps','StdEps', ...
              'SigXi','MPIncreaseSA','MPDecreaseSA','MPIncreaseSH','MPDecreaseSH', ...
              'MPIncreaseSL','MPDecreaseSL','exitProb','errtol'};

paramMat = [r;ddelta;eeta;ggamma;bl;gg;b;ubi; ...
            MaxUI;bRet;kkappa;ssigma;nnu;T;TYoung;TOld;TScar; ...
            llambu;llambe;aalphah;lb.a;lb.h;lb.l;lb.b;lb.t; ...
            lb.w;ub.a;ub.h;ub.l;ub.b;ub.t;ub.w;delt.h;delt.l; ...
            Nd;Na;Nb;Nw;Nh;Nl;na;nw;nt;N;NScar; ...
            S;MuA;MuH;MuL;SigA;SigH;SigL;SigAL;SigAH;SigHL; ...
            bbeta;w0;freq;Epsnodes;MuEps;SigEps;StdEps;SigXi; ...
            MPIncreaseSA;MPDecreaseSA;MPIncreaseSH;MPDecreaseSH; ...
            MPIncreaseSL;MPDecreaseSL;exitProb;errtol];

dlmwrite(fullfile(pwd,opts.results_path,'/tables/','ParamEstimates.csv'),cat(2,'Param,','Value'),'');
fid = fopen(fullfile(pwd,opts.results_path,'/tables/','ParamEstimates.csv'),'a');
for i = 1:length(paramNames)
    fprintf(fid,'%s,%f,\n',paramNames{i},paramMat(i));
end
fclose(fid);


% %% Parameters Values
% paramArray = [order num2cell(params)];
% % paramArray(find(strcmp(order, 'cons_pen')),:) = [];
% table_path = fullfile(pwd,opts.results_path,'/tables/');
% fid = fopen(strcat(table_path,'ParamEstimates.csv'), 'w');
% % fid = fopen(opts.results_path,'params.csv', 'w');
% fprintf(fid, 'Param,');
% fprintf(fid, 'Value\n');
% fclose(fid);
% %dlmwrite('params.csv', paramArray, '-append') ;
% fid = fopen(strcat(table_path,'ParamEstimates.csv'), 'a+');
% % fid = fopen('params.csv', 'a+');
% if fid>0
%      for k=1:size(paramArray,1)
%          fprintf(fid,'%s,%f\n',paramArray{k,:});
%      end
%      fclose(fid);
% end


end
